package com.gxwebsoft.common.system.controller;

import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.system.entity.SysFileType;
import com.gxwebsoft.common.system.param.SysFileTypeParam;
import com.gxwebsoft.common.system.service.SysFileTypeService;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 存储类型控制器
 *
 * @author 科技小王子
 * @since 2025-05-16 14:24:28
 */
@Tag(name = "存储类型管理")
@RestController
@RequestMapping("/api/system/sys-file-type")
public class SysFileTypeController extends BaseController {
    @Resource
    private SysFileTypeService sysFileTypeService;

    @PreAuthorize("hasAuthority('sys:sysFileType:list')")
    @Operation(summary = "分页查询存储类型")
    @GetMapping("/page")
    public ApiResult<PageResult<SysFileType>> page(SysFileTypeParam param) {
        // 使用关联查询
        return success(sysFileTypeService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('sys:sysFileType:list')")
    @Operation(summary = "查询全部存储类型")
    @GetMapping()
    public ApiResult<List<SysFileType>> list(SysFileTypeParam param) {
        // 使用关联查询
        return success(sysFileTypeService.listRel(param));
    }

    @PreAuthorize("hasAuthority('sys:sysFileType:list')")
    @Operation(summary = "根据id查询存储类型")
    @GetMapping("/{id}")
    public ApiResult<SysFileType> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(sysFileTypeService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('sys:sysFileType:save')")
    @OperationLog
    @Operation(summary = "添加存储类型")
    @PostMapping()
    public ApiResult<?> save(@RequestBody SysFileType sysFileType) {
        if (sysFileTypeService.save(sysFileType)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:sysFileType:update')")
    @OperationLog
    @Operation(summary = "修改存储类型")
    @PutMapping()
    public ApiResult<?> update(@RequestBody SysFileType sysFileType) {
        if (sysFileTypeService.updateById(sysFileType)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:sysFileType:remove')")
    @OperationLog
    @Operation(summary = "删除存储类型")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (sysFileTypeService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('sys:sysFileType:save')")
    @OperationLog
    @Operation(summary = "批量添加存储类型")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<SysFileType> list) {
        if (sysFileTypeService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:sysFileType:update')")
    @OperationLog
    @Operation(summary = "批量修改存储类型")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<SysFileType> batchParam) {
        if (batchParam.update(sysFileTypeService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:sysFileType:remove')")
    @OperationLog
    @Operation(summary = "批量删除存储类型")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (sysFileTypeService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
